Attribute VB_Name = "ModFileIO"
Option Explicit

Public DataSize&


Public TempTempo As Byte
Public TempKitNo As Byte
Public TempKitPitch As Byte

Public TempPercVal As Byte
Public TempPercMute As Boolean
Public TempKitParams1(23) As KIT_INFO_1
Public TempKitEdit As KIT_EDIT
Public TempKitParams2(23, 1599) As KIT_INFO_2

Public TempSynthPatchValue As Integer
Public TempSynthVolume As Integer
Public TempSynthPan As Integer
Public TempSynthModulation As Integer
Public TempSynthPortaOnOff As Integer
Public TempSynthPortaTime As Integer
Public TempSynthSustain As Integer
Public TempSynthMute As Boolean
Public TempSynthParams1(14) As SYNTH_INFO_1

Public TempNoteLength As Single
Public TempSynthVelocity As Integer
Public TempSynthParams2(14, 1599) As SYNTH_INFO_2

Public DispName$
Public TempSynthParams3(74, 1599) As SYNTH_INFO_3

Public TempWaveVols(23) As Byte
Public TempWavePans(23) As Byte
Public TempWaveHz%(23)
Public TempWaveMute(23) As Boolean
Public TempWaveName As String
Public TempWavePath(23) As String
Public TempWaveTriggers(23, 1599) As Boolean

Public TempSong(499) As Byte
    
    
Private Const MSSF_TAG As Long = 1179865933
Private Const TMPO_TAG As Long = 1330662740

Private Const KITD_TAG As Long = 1146374475
Private Const KITE_TAG As Long = 1163151691
Private Const KITM_TAG As Long = 1297369419
Private Const KITN_TAG As Long = 1314146635
Private Const KITP_TAG As Long = 1347701067
Private Const KITR_TAG As Long = 1381255499

Private Const SYND_TAG As Long = 1145985363
Private Const SYNE_TAG As Long = 1162762579
Private Const SYNI_TAG As Long = 1229871443

Private Const WAVD_TAG As Long = 1146503511
Private Const WAVF_TAG As Long = 1180057943
Private Const WAVM_TAG As Long = 1297498455
Private Const WAVN_TAG As Long = 1314275671
Private Const WAVP_TAG As Long = 1347830103
Private Const WAVV_TAG As Long = 1448493399

Private Const SONG_TAG As Long = 1196314451
Public Function GetFileName(Owner&, DialogToUse%) As FILEINFO

    Dim Rv&
    Dim OFN As OPENFILENAME

    With OFN
         Select Case DialogToUse
                Case 1
                    .flags = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY
                    .lpstrDefExt = ""
                    .lpstrFilter = "MicroStudio File (*.msf)" & vbNullChar & "*.msf" & vbNullChar & vbNullChar
                    .lpstrTitle = TTL & " - Open"
                Case 2
                    .flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
                    .lpstrDefExt = ".msf"
                    .lpstrFilter = "MicroStudio File (*.msf)" & vbNullChar & "*.msf" & vbNullChar & vbNullChar
                    .lpstrTitle = TTL & " - Save As"
                Case 3
                    .flags = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY
                    .lpstrDefExt = ""
                    .lpstrFilter = "Wave File (*.wav)" & vbNullChar & "*.wav" & vbNullChar & vbNullChar
                    .lpstrTitle = TTL & " - Import Wave Sample"
                Case 4
                    .flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
                    .lpstrDefExt = ".wav"
                    .lpstrFilter = "Wave File (*.wav)" & vbNullChar & "*.wav" & vbNullChar & vbNullChar
                    .lpstrTitle = TTL & " - Save Recording As"
         End Select
        .hInstance = App.hInstance
        .hwndOwner = Owner
        .lpstrFile = String(MAX_PATH, 0)
        .lpstrFileTitle = String(MAX_FILE, 0)
        .lStructSize = Len(OFN)
        .nFilterIndex = 1
        .nMaxFile = MAX_PATH
        .nMaxFileTitle = MAX_FILE
    End With

    Select Case DialogToUse
           Case 1, 3
                Rv = GetOpenFileName(OFN)
           Case 2, 4
                Rv = GetSaveFileName(OFN)
    End Select
    DoEvents

    If Rv = 1 Then
       GetFileName.bSuccess = True
       GetFileName.fiFileName = Left(OFN.lpstrFile, InStr(OFN.lpstrFile, vbNullChar) - 1)
       GetFileName.fiFileTitle = Left(OFN.lpstrFileTitle, InStr(OFN.lpstrFileTitle, vbNullChar) - 1)
    End If

End Function
Public Function GetWaveData(PaFn$) As Boolean

    Dim hmmio&, Rv&
    Dim MMioParentInfo As MMCKINFO
    Dim MMioSubChunkInfo As MMCKINFO

    hmmio = mmioOpen(PaFn, 0, MMIO_READ Or MMIO_ALLOCBUF)
    If hmmio = 0 Then
       Exit Function
    End If

    MMioParentInfo.fccType = mmioStringToFOURCC("WAVE", 0)
    Rv = mmioDescendByVal(hmmio, MMioParentInfo, 0, MMIO_FINDRIFF)
    If Rv <> 0 Then
       mmioClose hmmio, 0
       Exit Function
    End If

    MMioSubChunkInfo.ckid = mmioStringToFOURCC("fmt", 0)
    Rv = mmioDescend(hmmio, MMioSubChunkInfo, MMioParentInfo, MMIO_FINDCHUNK)
    If Rv <> 0 Then
       mmioClose hmmio, 0
       Exit Function
    End If

    Rv = mmioReadStruct(hmmio, WF, Len(WF))
    If Rv <> Len(WF) Then
       mmioClose hmmio, 0
       Exit Function
    End If

    If WF.nFormatTag <> 1 Then
       mmioClose hmmio, 0
       Exit Function
    End If

    mmioAscend hmmio, MMioSubChunkInfo, 0

    MMioSubChunkInfo.ckid = mmioStringToFOURCC("data", 0)
    Rv = mmioDescend(hmmio, MMioSubChunkInfo, MMioParentInfo, MMIO_FINDCHUNK)
    If Rv <> 0 Then
       mmioClose hmmio, 0
       Exit Function
    End If

    If MMioSubChunkInfo.ckSize = 0 Then
       mmioClose hmmio, 0
       Exit Function
    Else
       DataSize = MMioSubChunkInfo.ckSize
    End If

    mmioClose hmmio, 0
    GetWaveData = True

End Function
Public Function WriteDataToFile(Fn$) As Boolean

    Dim WavFil$
    Dim F%, K&, R%, C%
    Dim bFileOpen As Boolean

    On Error Resume Next
       Kill Fn
       If Err.Number Then Err.Clear
    On Error GoTo 0
    
    On Error GoTo SaveError
    
    F = FreeFile
    Open Fn For Binary Access Write As #F
         bFileOpen = True
         Put #F, , MSSF_TAG
         Put #F, , TMPO_TAG
         Put #F, , CByte(FrmStudio.VsbTempo.Value)

         Put #F, , KITN_TAG
         Put #F, , CByte(CurKit)
         Put #F, , KITP_TAG
         Put #F, , CByte(FrmStudio.VsbKitPitch.Value)
         Put #F, , KITR_TAG
         For K = 0 To 23
             Put #F, , CByte(KitParams1(K).kiPercVal)
         Next
         Put #F, , KITM_TAG
         For K = 0 To 23
             Put #F, , KitParams1(K).kiMute
         Next
         Put #F, , KITE_TAG
         Put #F, , KitEdit
         Put #F, , KITD_TAG
         Put #F, , KitParams2()

         Put #F, , SYNE_TAG
         For K = 0 To 14
             With SynthParams1(K)
                  Put #F, , .siPatchValue
                  Put #F, , .siVolume
                  Put #F, , .siPan
                  Put #F, , .siModulation
                  Put #F, , .siPortaOnOff
                  Put #F, , .siPortaTime
                  Put #F, , .siSustain
                  Put #F, , .siMute
             End With
         Next
         Put #F, , SYNI_TAG
         For R = 0 To 14
             For C = 0 To 1599
                 Put #F, , SynthParams2(R, C).siNoteLength
                 Put #F, , SynthParams2(R, C).siVelocity
             Next
          Next
          Put #F, , SYND_TAG
          Put #F, , SynthParams3()
             
          Put #F, , WAVV_TAG
          For K = 0 To 23
              Put #F, , CByte(FrmStudio.VsbWaveVol(K).Value)
          Next
          Put #F, , WAVP_TAG
          For K = 0 To 23
              Put #F, , CByte(FrmStudio.VsbWavePan(K).Value)
          Next
          Put #F, , WAVF_TAG
          For K = 0 To 23
              Put #F, , CInt(FrmStudio.VsbHz(K).Value)
          Next
          Put #F, , WAVM_TAG
          Put #F, , WaveMute()
          Put #F, , WAVN_TAG
          For K = 0 To 23
              WavFil = WavePath(K)
              WavFil = WavFil & String(MAX_PATH - Len(WavFil), vbNullChar)
              Put #F, , WavFil
          Next
          Put #F, , WAVD_TAG
          Put #F, , WaveTriggers()

          Put #F, , SONG_TAG
          Put #F, , Song()
    Close #F

    bFileOpen = False
    WriteDataToFile = True
    On Error GoTo 0
    Exit Function

SaveError:

    Err.Clear
    If bFileOpen Then Close #F
    WriteDataToFile = False
    Exit Function

End Function
Public Function LooksValid(FName$) As Boolean

    Dim F%, Tg&
    Dim bFileOpen As Boolean
    
    Dim K&, L&
    L = FileLen(FName)
    
    On Error GoTo ValidError
       F = FreeFile
       Open FName For Binary Access Read As #F
            bFileOpen = True
            Get #F, 1, Tg
            If Tg <> MSSF_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 5, Tg
            If Tg <> TMPO_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 10, Tg
            If Tg <> KITN_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 15, Tg
            If Tg <> KITP_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 20, Tg
            If Tg <> KITR_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 48, Tg
            If Tg <> KITM_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 100, Tg
            If Tg <> KITE_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 116, Tg
            If Tg <> KITD_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 537720, Tg
            If Tg <> SYNE_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 537964, Tg
            If Tg <> SYNI_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 681968, Tg
            If Tg <> SYND_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 1641972, Tg
            If Tg <> WAVV_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 1642000, Tg
            If Tg <> WAVP_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 1642028, Tg
            If Tg <> WAVF_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 1642080, Tg
            If Tg <> WAVM_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 1642132, Tg
            If Tg <> WAVN_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 1648376, Tg
            If Tg <> WAVD_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If
            Get #F, 1725180, Tg
            If Tg <> SONG_TAG Then
               LooksValid = False
               Close #F
               Exit Function
            End If

'            For K = 1 To L
'                Get #F, K, Tg
'                Select Case Tg
'                       Case MSSF_TAG: Debug.Print K
'                       Case TMPO_TAG: Debug.Print K
'                       Case KITN_TAG: Debug.Print K
'                       Case KITP_TAG: Debug.Print K
'                       Case KITR_TAG: Debug.Print K
'                       Case KITM_TAG: Debug.Print K
'                       Case KITE_TAG: Debug.Print K
'                       Case KITD_TAG: Debug.Print K
'                       Case SYNE_TAG: Debug.Print K
'                       Case SYNI_TAG: Debug.Print K
'                       Case SYND_TAG: Debug.Print K
'                       Case WAVV_TAG: Debug.Print K
'                       Case WAVP_TAG: Debug.Print K
'                       Case WAVF_TAG: Debug.Print K
'                       Case WAVM_TAG: Debug.Print K
'                       Case WAVN_TAG: Debug.Print K
'                       Case WAVD_TAG: Debug.Print K
'                       Case SONG_TAG: Debug.Print K
'                End Select
'            Next
       Close #F
       bFileOpen = False
    On Error GoTo 0

    LooksValid = True
    Exit Function
    
ValidError:

    Err.Clear
    If bFileOpen Then Close #F
    LooksValid = False
    Exit Function

End Function
Public Function LoadData(FName$) As Boolean

    Dim R%, C%
    Dim NullPos%
    Dim F%, K&, P&
    Dim bFileOpen As Boolean
    Dim bFound As Boolean

    Erase TempKitParams1
    Erase TempKitParams2
    Erase TempSynthParams1
    Erase TempSynthParams2
    Erase TempSynthParams3
    Erase TempWaveVols
    Erase TempWavePans
    Erase TempWaveHz
    Erase TempWaveMute
    Erase TempWavePath
    Erase TempWaveTriggers
    Erase TempSong

    On Error GoTo LoadError
       F = FreeFile
       Open FName For Binary Access Read As #F
            bFileOpen = True
            Get #F, 9, TempTempo
            If TempTempo < 40 Or TempTempo > 240 Then
               Close #F
               LoadData = False
               Exit Function
            End If
            Get #F, 14, TempKitNo
            If TempKitNo > 6 Then
               Close #F
               LoadData = False
               Exit Function
            End If
            Get #F, 19, TempKitPitch
            If TempKitPitch > 127 Then
               Close #F
               LoadData = False
               Exit Function
            End If
            P = 24
            For K = 0 To 23
                Get #F, P, TempPercVal
                If TempPercVal < 35 Or TempPercVal > 81 Then
                   Close #F
                   LoadData = False
                   Exit Function
                Else
                   With TempKitParams1(K)
                       .kiPercVal = TempPercVal
                       .kiPercName = LoadResString(TempPercVal)
                   End With
                End If
                P = P + 1
            Next
            P = 52
            For K = 0 To 23
                Get #F, P, TempPercMute
                If TempPercMute < -1 Or TempPercMute > 0 Then
                   Close #F
                   LoadData = False
                   Exit Function
                Else
                   TempKitParams1(K).kiMute = TempPercMute
                End If
                P = P + 2
            Next
            Get #F, 104, TempKitEdit
            With TempKitEdit
                 If .keModulation < 0 Or .keModulation > 127 Then
                    Close #F
                    LoadData = False
                    Exit Function
                 End If
                 If .kePan < 0 Or .kePan > 127 Then
                    Close #F
                    LoadData = False
                    Exit Function
                 End If
                 If Not (.kePortaOnOff = 0 Or .kePortaOnOff = 127) Then
                    Close #F
                    LoadData = False
                    Exit Function
                 End If
                 If .kePortaTime < 0 Or .kePortaTime > 127 Then
                    Close #F
                    LoadData = False
                    Exit Function
                 End If
                 If Not (.keSustain = 0 Or .keSustain = 127) Then
                    Close #F
                    LoadData = False
                    Exit Function
                 End If
                 If .keVolume < 0 Or .keVolume > 127 Then
                    Close #F
                    LoadData = False
                    Exit Function
                 End If
            End With
            Get #F, 120, TempKitParams2()
            For R = 0 To 23
                For C = 0 To 1599
                    With TempKitParams2(R, C)
                         If .kiMidiMsgOn < 0 Or .kiMidiMsgOn > &HFFFFFF Then
                            Close #F
                            LoadData = False
                            Exit Function
                         End If
                         If .KiMidiMsgOff < 0 Or .KiMidiMsgOff > &HFFFF& Then
                            Close #F
                            LoadData = False
                            Exit Function
                         End If
                         For K = 0 To 16
                             If .kiVelocity = VelArray(K) Then
                                bFound = True
                                Exit For
                             End If
                         Next
                         If bFound Then
                            bFound = False
                         Else
                            Close #F
                            LoadData = False
                            Exit Function
                         End If
                         For K = 0 To 16
                             If .kiColor = PalColors(K) Then
                                bFound = True
                                Exit For
                             End If
                         Next
                    End With
                    If bFound Then
                       bFound = False
                    Else
                       Close #F
                       LoadData = False
                       Exit Function
                    End If
                Next
            Next
            P = 537724
            For K = 0 To 14
                Get #F, P, TempSynthPatchValue
                Get #F, P + 2, TempSynthVolume
                Get #F, P + 4, TempSynthPan
                Get #F, P + 6, TempSynthModulation
                Get #F, P + 8, TempSynthPortaOnOff
                Get #F, P + 10, TempSynthPortaTime
                Get #F, P + 12, TempSynthSustain
                Get #F, P + 14, TempSynthMute
                With TempSynthParams1(K)
                     If TempSynthPatchValue < 0 Or TempSynthPatchValue > 127 Then
                        Close #F
                        LoadData = False
                        Exit Function
                     Else
                        .siPatchName = LoadResString(TempSynthPatchValue + 100)
                        .siPatchValue = TempSynthPatchValue
                     End If
                     If TempSynthVolume < 0 Or TempSynthVolume > 127 Then
                        Close #F
                        LoadData = False
                        Exit Function
                     Else
                        .siVolume = TempSynthVolume
                     End If
                     If TempSynthPan < 0 Or TempSynthPan > 127 Then
                        Close #F
                        LoadData = False
                        Exit Function
                     Else
                        .siPan = TempSynthPan
                     End If
                     If TempSynthModulation < 0 Or TempSynthModulation > 127 Then
                        Close #F
                        LoadData = False
                        Exit Function
                     Else
                        .siModulation = TempSynthModulation
                     End If
                     If Not (TempSynthPortaOnOff = 0 Or TempSynthPortaOnOff = 127) Then
                        Close #F
                        LoadData = False
                        Exit Function
                     Else
                        .siPortaOnOff = TempSynthPortaOnOff
                     End If
                     If TempSynthPortaTime < 0 Or TempSynthPortaTime > 127 Then
                        Close #F
                        LoadData = False
                        Exit Function
                     Else
                        .siPortaTime = TempSynthPortaTime
                     End If
                     If Not (TempSynthSustain = 0 Or TempSynthSustain = 127) Then
                        Close #F
                        LoadData = False
                        Exit Function
                     Else
                        .siSustain = TempSynthSustain
                     End If
                     If TempSynthMute < -1 Or TempSynthMute > 0 Then
                        Close #F
                        LoadData = False
                        Exit Function
                     Else
                        .siMute = TempSynthMute
                     End If
                End With
                P = P + 16
            Next
            P = 537968
            For R = 0 To 14
                For C = 0 To 1599
                    Get #F, P, TempNoteLength
                    With TempSynthParams2(R, C)
                         If TempNoteLength < 0.05 Or TempNoteLength > 31.95 Then
                            Close #F
                            LoadData = False
                            Exit Function
                         Else
                           .siNoteLength = TempNoteLength
                         End If
                         Get #F, P + 4, TempSynthVelocity
                         If TempSynthVelocity < 0 Or TempSynthVelocity > 127 Then
                            Close #F
                            LoadData = False
                            Exit Function
                         Else
                           .siVelocity = TempSynthVelocity
                         End If
                    End With
                    P = P + 6
                Next
            Next
            P = 681972
            Get #F, P, TempSynthParams3()
            For R = 0 To 74
                For C = 0 To 1599
                    With TempSynthParams3(R, C)
                         If .MidiMsgOn < 0 Or .MidiMsgOn > &HFFFFFF Then
                             Close #F
                             LoadData = False
                             Exit Function
                         End If
                         If .MidiMsgOff < 0 Or .MidiMsgOff > &HFFFF& Then
                             Close #F
                             LoadData = False
                             Exit Function
                         End If
                         If R Mod 5 = 0 Then
                            If .MidiMsgOn > 0 Then
                                DispName = GetNoteText((.MidiMsgOff - &H80 - (R \ 5)) \ &H100)
                                If DispName = "?" Then DispName = ""
                                TempSynthParams2(R \ 5, C).siNoteDisplayName = DispName
                            End If
                         End If
                    End With
                Next
            Next
            If bDxAvailable Then
               P = 1641976
               Get #F, P, TempWaveVols()
               For K = 0 To 23
                   If TempWaveVols(K) < 0 Or TempWaveVols(K) > 100 Then
                      Close #F
                      LoadData = False
                      Exit Function
                   End If
               Next
               P = 1642004
               Get #F, P, TempWavePans()
               For K = 0 To 23
                   If TempWavePans(K) < 0 Or TempWavePans(K) > 99 Then
                      Close #F
                      LoadData = False
                      Exit Function
                   End If
               Next
               P = 1642032
               Get #F, P, TempWaveHz()
               For K = 0 To 23
                   If TempWaveHz(K) < 10 Or TempWaveHz(K) > 9999 Then
                      Close #F
                      LoadData = False
                      Exit Function
                   End If
               Next
               P = 1642084
               Get #F, P, TempWaveMute()
               For K = 0 To 23
                   If TempWaveMute(K) < -1 Or TempWaveMute(K) > 0 Then
                      Close #F
                      LoadData = False
                      Exit Function
                   End If
               Next
               P = 1642136
               For K = 0 To 23
                   TempWaveName = String(MAX_PATH, 0)
                   Get #F, P, TempWaveName
                   If Left(TempWaveName, 1) <> vbNullChar Then
                      NullPos = InStr(TempWaveName, vbNullChar)
                      If NullPos = 0 Then
                         TempWavePath(K) = TempWaveName
                      Else
                         TempWavePath(K) = Left(TempWaveName, NullPos - 1)
                      End If
                   End If
                   P = P + MAX_PATH
               Next
               P = 1648380
               Get #F, P, TempWaveTriggers()
               For R = 0 To 23
                   For C = 0 To 1599
                       If TempWaveTriggers(R, C) < -1 Or TempWaveTriggers(R, C) > 0 Then
                          Close #F
                          LoadData = False
                          Exit Function
                       End If
                   Next
               Next
            End If
            P = 1725184
            Get #F, P, TempSong()
            For K = 0 To 499
                If TempSong(K) > 100 Then
                   Close #F
                   LoadData = False
                   Exit Function
                End If
            Next
       Close #F
       bFileOpen = False
    On Error GoTo 0
   
    LoadData = True
    Exit Function
    
LoadError:

    Err.Clear
    If bFileOpen Then Close #F
    LoadData = False
    Exit Function

End Function
