Attribute VB_Name = "ModMain"
Option Explicit

Public bDxAvailable As Boolean
Public bDirty As Boolean
Public bLoopSong As Boolean
Public bRecorded As Boolean

Public Channel%
Public NumDevs&
Public BestRes&
Public TimerID&
Public hMidiOut&
Public MixerPath$
Public TempFile$

Public CurInterval!
Public PrevInterval!

Public InstName$
Public InstValue%

Public PercName$
Public PercValue%
Public CurKit%
Public DemoKitTrack%
Public DemoSynthChannel%

Public StartPos%
Public EndPos%
Public CurPos%

Public SongStartPos%
Public SongEndPos%
Public SongPos%
Public SongPtr%

Public MouseColors&(1)
Public Velocities%(1)

Public PalColors&(16)
Public VelArray%(16)

Type FILEINFO
     fiFileName As String
     fiFileTitle As String
     bSuccess As Boolean
End Type

Type OPENFILENAME
     lStructSize As Long
     hwndOwner As Long
     hInstance As Long
     lpstrFilter As String
     lpstrCustomFilter As String
     nMaxCustFilter As Long
     nFilterIndex As Long
     lpstrFile As String
     nMaxFile As Long
     lpstrFileTitle As String
     nMaxFileTitle As Long
     lpstrInitialDir As String
     lpstrTitle As String
     flags As Long
     nFileOffset As Integer
     nFileExtension As Integer
     lpstrDefExt As String
     lCustData As Long
     lpfnHook As Long
     lpTemplateName As String
End Type

Type MIDIOUTCAPS
     wMid As Integer
     wPid As Integer
     vDriverVersion As Long
     szPname As String * 32
     wTechnology As Integer
     wVoices As Integer
     wNotes As Integer
     wChannelMask As Integer
     dwSupport As Long
End Type

Type MMCKINFO
     ckid As Long
     ckSize As Long
     fccType As Long
     dwDataOffset As Long
     dwFlags As Long
End Type

Type OSVERSIONINFO
     dwOSVersionInfoSize As Long
     dwMajorVersion As Long
     dwMinorVersion As Long
     dwBuildNumber As Long
     dwPlatformId As Long
     szCSDVersion As String * 128
End Type

Type RECT
     rLeft As Long
     rTop As Long
     rRight As Long
     rBottom As Long
End Type

Type TIMECAPS
     wPeriodMin As Long
     wPeriodMax As Long
End Type

Type SECURITY_ATTRIBUTES
     nLength As Long
     lpSecurityDescriptor As Long
     bInheritHandle As Long
End Type

Type KIT_EDIT
     keVolume As Integer
     kePan As Integer
     keModulation As Integer
     kePortaOnOff As Integer
     kePortaTime As Integer
     keSustain As Integer
End Type

Public KitEdit As KIT_EDIT

Type KIT_INFO_1
     kiPercName As String
     kiPercVal As Integer
     kiMute As Boolean
End Type

Public KitParams1(23) As KIT_INFO_1

Type KIT_INFO_2
     kiMidiMsgOn As Long
     KiMidiMsgOff As Long
     kiVelocity As Integer
     kiColor As Long
End Type

Public KitParams2(23, 1599) As KIT_INFO_2

Type SYNTH_INFO_1
     siPatchName As String
     siPatchValue As Integer
     siVolume As Integer
     siPan As Integer
     siModulation As Integer
     siPortaOnOff As Integer
     siPortaTime As Integer
     siSustain As Integer
     siMute As Boolean
End Type

Public SynthParams1(14) As SYNTH_INFO_1

Type SYNTH_INFO_2
     siNoteDisplayName As String
     siNoteLength As Single
     siVelocity As Integer
End Type

Public SynthParams2(14, 1599) As SYNTH_INFO_2

Type SYNTH_INFO_3
     MidiMsgOn As Long
     MidiMsgOff As Long
End Type

Public SynthParams3(74, 1599) As SYNTH_INFO_3
Public NoteLens(74, 1599) As New cTimer

Public Song(499) As Byte

Public DX7 As New DirectX7
Public DS As DirectSound
Public BD As DSBUFFERDESC
Public WF As WAVEFORMATEX

Public WaveBuffers(23) As DirectSoundBuffer
Public WaveTriggers(23, 1599) As Boolean
Public WaveMute(23) As Boolean
Public WavePath$(23)

Declare Function CreateRectRgn& Lib "gdi32" (ByVal x1&, ByVal y1&, ByVal x2&, ByVal y2&)
Declare Function DeleteObject& Lib "gdi32" (ByVal hObject&)
Declare Function DrawEdge& Lib "user32" (ByVal ahDc&, lpRect As RECT, ByVal nEdge&, ByVal nFlags&)
Declare Function DrawIconEx& Lib "user32" (ByVal ahDc&, ByVal x1&, ByVal y1&, ByVal hIcon&, ByVal nWidth&, ByVal nHeight&, ByVal istepIfAniCur&, ByVal hbrFlickerFreeDraw&, ByVal diFlags&)
Declare Function GetDC& Lib "user32" (ByVal ahWnd&)
Declare Function GetDeviceCaps& Lib "gdi32" (ByVal ahDc&, ByVal nIndex&)
Declare Function GetOpenFileName& Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME)
Declare Function GetSaveFileName& Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME)
Declare Function GetSystemMetrics& Lib "user32" (ByVal nIndex&)
Declare Function GetTempPath& Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength&, ByVal lpBuffer$)
Declare Function GetVersionEx& Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO)
Declare Function GetWindowsDirectory& Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer$, ByVal nSize&)
Declare Function PtInRect& Lib "user32" (lpRect As RECT, ByVal Px&, ByVal Py&)
Declare Function SetRect& Lib "user32" (lpRect As RECT, ByVal x1&, ByVal y1&, ByVal x2&, ByVal y2&)
Declare Function SetWindowRgn& Lib "user32" (ByVal ahWnd&, ByVal hRgn&, ByVal bRedraw&)

Declare Function mciSendString& Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand$, ByVal lpstrReturnString$, ByVal uReturnLength&, ByVal hwndCallback&)

Declare Function midiOutClose& Lib "winmm.dll" (ByVal hMidiOut&)
Declare Function midiOutGetDevCaps& Lib "winmm.dll" Alias "midiOutGetDevCapsA" (ByVal uDeviceID&, lpCaps As MIDIOUTCAPS, ByVal uSize&)
Declare Function midiOutGetNumDevs& Lib "winmm.dll" ()
Declare Function midiOutOpen& Lib "winmm.dll" (lphMidiOut&, ByVal uDeviceID&, ByVal dwCallback&, ByVal dwInstance&, ByVal dwFlags&)
Declare Function midiOutReset& Lib "winmm.dll" (ByVal hMidiOut&)
Declare Function midiOutShortMsg& Lib "winmm.dll" (ByVal hMidiOut&, ByVal dwMsg&)

Declare Function mmioAscend& Lib "winmm.dll" (ByVal hmmio&, lpck As MMCKINFO, ByVal uFlags&)
Declare Function mmioClose& Lib "winmm.dll" (ByVal hmmio&, ByVal uFlags&)
Declare Function mmioDescend& Lib "winmm.dll" (ByVal hmmio&, lpck As MMCKINFO, lpckParent As MMCKINFO, ByVal uFlags&)
Declare Function mmioDescendByVal& Lib "winmm.dll" Alias "mmioDescend" (ByVal hmmio&, lpck As MMCKINFO, ByVal lpckParent&, ByVal uFlags&)
Declare Function mmioOpen& Lib "winmm.dll" Alias "mmioOpenA" (ByVal szFileName$, ByVal mmioinfo&, ByVal dwOpenFlags&)
Declare Function mmioStringToFOURCC& Lib "winmm.dll" Alias "mmioStringToFOURCCA" (ByVal sz$, ByVal uFlags&)
Declare Function mmioRead& Lib "winmm.dll" (ByVal hmmio&, ByVal pch$, ByVal cch&)
Declare Function mmioReadStruct& Lib "winmm.dll" Alias "mmioRead" (ByVal hmmio&, pch As WAVEFORMATEX, ByVal cch&)

Declare Function timeBeginPeriod& Lib "winmm.dll" (ByVal uPeriod&)
Declare Function timeEndPeriod& Lib "winmm.dll" (ByVal uPeriod&)
Declare Function timeGetDevCaps& Lib "winmm.dll" (lpTimeCaps As TIMECAPS, ByVal uSize&)
Declare Function timeKillEvent& Lib "winmm.dll" (ByVal uId&)
Declare Function timeSetEvent& Lib "winmm.dll" (ByVal uDelay&, ByVal uResolution&, ByVal lpFunction&, ByVal dwUser&, ByVal uFlags&)

Declare Function RegCloseKey& Lib "advapi32.dll" (ByVal hKey&)
Declare Function RegCreateKeyEx& Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey&, ByVal lpSubKey$, ByVal Reserved&, ByVal lpClass$, ByVal dwOptions&, ByVal samDesired&, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult&, lpdwDisposition&)
Declare Function RegDeleteValue& Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey&, ByVal lpValueName$)
Declare Function RegOpenKeyEx& Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey&, ByVal lpSubKey$, ByVal ulOptions&, ByVal samDesired&, phkResult&)
Declare Function RegQueryValueEx& Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey&, ByVal lpValueName$, ByVal lpReserved&, lpType&, ByVal lpData$, lpcbData&)
Declare Function RegSetValueEx& Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey&, ByVal lpValueName$, ByVal Reserved&, ByVal dwType&, ByVal lpData$, ByVal cbData&)

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const KEY_ALL_ACCESS = &HF003F

Public Const KEY_VELOCITY = &H640000

Public Const MMIO_ALLOCBUF = &H10000
Public Const MMIO_FINDCHUNK = &H10
Public Const MMIO_FINDRIFF = &H20
Public Const MMIO_READ = &H0

Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800

Public Const MAX_PATH = 260
Public Const MAX_FILE = 256

Public Const MIDI_MAPPER = -1&

Public Const CHANNEL_MODULATION_CONTROLLER = 1
Public Const CHANNEL_VOLUME_CONTROLLER = 7
Public Const CHANNEL_PAN_CONTROLLER = 10
Public Const CHANNEL_SUSTAIN_CONTROLLER = 64
Public Const CHANNEL_PORTATIME_CONTROLLER = 5
Public Const CHANNEL_PORTAONOFF_CONTROLLER = 65

Public Const TTL = "MicroStudio"
Private Sub Main()

    #If Win32 Then
        If PrevInst Then End
        If Not ScreenOk Then End
        If Not MidiPresent Then End
        If Not HighResTimer Then End
        If Not DeviceOpen Then End
        CheckColorMode
        CreatePaletteEntries
        CreateVelocityArray
        CreateTempFileName
        GetMixerPath
        SetUpIconDblClick
        FrmStudio.Show
    #Else
        End
    #End If

End Sub
Private Function PrevInst() As Boolean

    Dim Msg$

    If App.PrevInstance Then
       Msg = TTL & " is already running."
       MsgBox Msg, vbInformation, TTL
       PrevInst = True
    End If

End Function
Private Function ScreenOk() As Boolean

    Dim Msg$

    If GetSystemMetrics(0) > 640 And GetSystemMetrics(1) > 480 Then
       ScreenOk = True
    Else
       Msg = TTL & " requires the size of your display to be at least 800 x 600 pixels."
       Msg = Msg & vbCrLf & vbCrLf
       Msg = Msg & "Please adjust your display and try again."
       MsgBox Msg, vbCritical, TTL & " - Error"
    End If

End Function
Private Sub CheckColorMode()

    Dim Msg$

    If GetDeviceCaps(GetDC(0), 12) <= 8 Then
       Msg = "The " & TTL & " interface was designed for at least high color mode."
       Msg = Msg & vbCrLf & vbCrLf
       Msg = Msg & "Adjusting your color mode will make working with " & TTL & " much more enjoyable."
       MsgBox Msg, vbInformation, TTL
    End If

End Sub
Private Function MidiPresent() As Boolean

    Dim Msg$

    NumDevs = midiOutGetNumDevs()

    If NumDevs Then
       MidiPresent = True
    Else
       Msg = "Unable to detect any midi output devices."
       Msg = Msg & vbCrLf & vbCrLf
       Msg = Msg & "Terminating..."
       MsgBox Msg, vbCritical, TTL & " - Error"
    End If

End Function
Private Function HighResTimer() As Boolean

    Dim Msg$, Rv&
    Dim TC As TIMECAPS

    Msg = "Unable to create high resolution timer."
    Msg = Msg & vbCrLf & vbCrLf
    Msg = Msg & "Terminating..."

    Rv = timeGetDevCaps(TC, Len(TC))
    If Rv = 0 Then
       BestRes = TC.wPeriodMin
       Rv = timeBeginPeriod(BestRes)
       If Rv = 0 Then
          HighResTimer = True
       Else
          MsgBox Msg, vbCritical, TTL & " - Error"
       End If
    Else
       MsgBox Msg, vbCritical, TTL & " - Error"
    End If

End Function
Private Function DeviceOpen() As Boolean

    Dim Msg$
    Dim Rv&

    Rv = midiOutOpen(hMidiOut, MIDI_MAPPER, 0, 0, 0)
    If Rv = 0 Then
       DeviceOpen = True
    Else
       timeEndPeriod BestRes
       Msg = "Unable to open midi output device."
       Msg = Msg & vbCrLf & vbCrLf
       Msg = Msg & "Terminating..."
       MsgBox Msg, vbCritical, TTL & " - Error"
    End If

End Function
Private Sub CreatePaletteEntries()

     PalColors(0) = &HFFFF00
     PalColors(1) = &HFFFF&
     PalColors(2) = &HFF00&
     PalColors(3) = &HFF&
     PalColors(4) = &HD4D400
     PalColors(5) = &HD4D4&
     PalColors(6) = &HD400&
     PalColors(7) = &HD4&
     PalColors(8) = &HAAAA00
     PalColors(9) = &HAAAA&
    PalColors(10) = &HAA00&
    PalColors(11) = &HAA&
    PalColors(12) = &H7F7F00
    PalColors(13) = &H7F7F&
    PalColors(14) = &H7F00&
    PalColors(15) = &H7F&
    PalColors(16) = &H0&

End Sub
Private Sub CreateVelocityArray()

     VelArray(0) = 127
     VelArray(1) = 120
     VelArray(2) = 112
     VelArray(3) = 104
     VelArray(4) = 96
     VelArray(5) = 88
     VelArray(6) = 80
     VelArray(7) = 72
     VelArray(8) = 64
     VelArray(9) = 56
    VelArray(10) = 48
    VelArray(11) = 40
    VelArray(12) = 32
    VelArray(13) = 24
    VelArray(14) = 16
    VelArray(15) = 8
    VelArray(16) = 0

End Sub
Private Sub CreateTempFileName()

    Dim Rv&
    Dim Buffer$
    
    Buffer = Space(MAX_PATH)
    Rv = GetTempPath(MAX_PATH, Buffer)
    TempFile = Left(Buffer, Rv) & "Abcdwxyz.wav"

End Sub
Private Sub GetMixerPath()

    Dim Windir$
    Dim NumChars&
    Dim OSVI As OSVERSIONINFO

    Windir = Space(MAX_PATH)
    NumChars = GetWindowsDirectory(Windir, MAX_PATH)
    Windir = Left(Windir, NumChars)

    OSVI.dwOSVersionInfoSize = Len(OSVI)
    GetVersionEx OSVI

    Select Case OSVI.dwPlatformId
           Case 1
                MixerPath = Windir & "\SndVol32.exe"
           Case 2
                MixerPath = Windir & "\System32\SndVol32.exe"
    End Select

End Sub
Public Sub InitDX7()

    Dim Msg$

    On Error GoTo DxError
       Set DS = DX7.DirectSoundCreate("")
       DS.SetCooperativeLevel FrmStudio.hWnd, DSSCL_PRIORITY
    On Error GoTo 0

    bDxAvailable = True
    Exit Sub

DxError:

    Err.Clear
    Msg = "Unable to create direct sound object."
    Msg = Msg & vbCrLf & vbCrLf
    Msg = Msg & "Wave sequencing will not be available."
    MsgBox Msg, vbExclamation, TTL & " - Error"
    bDxAvailable = False
    Exit Sub

End Sub
Public Sub PositionForm(Frm As Form)

    With Frm
        .Move (Screen.Width - .Width) \ 2, (Screen.Height - .Height) \ 3
    End With

End Sub
Public Function GetChordName$(Idx%)

    Dim ChordName$

    Select Case Idx
           Case 0: ChordName = "Note"
           Case 1: ChordName = "Major"
           Case 2: ChordName = "Minor"
           Case 3: ChordName = "Major 7th"
           Case 4: ChordName = "Minor 7th"
           Case 5: ChordName = "Minor 7th-5"
           Case 6: ChordName = "Diminished"
           Case 7: ChordName = "Dominant 7th"
           Case 8: ChordName = "Major 9th"
           Case 9: ChordName = "Minor 9th"
          Case 10: ChordName = "Octave"
    End Select

    GetChordName = ChordName

End Function
Public Function GetNoteText$(NoteNum&)

    Dim N$

    Select Case NoteNum
           Case 0: N = "C-1"
           Case 1: N = "C#-1"
           Case 2: N = "D-1"
           Case 3: N = "D#-1"
           Case 4: N = "E-1"
           Case 5: N = "F-1"
           Case 6: N = "F#-1"
           Case 7: N = "G-1"
           Case 8: N = "G#-1"
           Case 9: N = "A-1"
          Case 10: N = "A#-1"
          Case 11: N = "B-1"
          Case 12: N = "C0"
          Case 13: N = "C#0"
          Case 14: N = "D0"
          Case 15: N = "D#0"
          Case 16: N = "E0"
          Case 17: N = "F0"
          Case 18: N = "F#0"
          Case 19: N = "G0"
          Case 20: N = "G#0"
          Case 21: N = "A0"
          Case 22: N = "A#0"
          Case 23: N = "B0"
          Case 24: N = "C1"
          Case 25: N = "C#1"
          Case 26: N = "D1"
          Case 27: N = "D#1"
          Case 28: N = "E1"
          Case 29: N = "F1"
          Case 30: N = "F#1"
          Case 31: N = "G1"
          Case 32: N = "G#1"
          Case 33: N = "A1"
          Case 34: N = "A#1"
          Case 35: N = "B1"
          Case 36: N = "C2"
          Case 37: N = "C#2"
          Case 38: N = "D2"
          Case 39: N = "D#2"
          Case 40: N = "E2"
          Case 41: N = "F2"
          Case 42: N = "F#2"
          Case 43: N = "G2"
          Case 44: N = "G#2"
          Case 45: N = "A2"
          Case 46: N = "A#2"
          Case 47: N = "B2"
          Case 48: N = "C3"
          Case 49: N = "C#3"
          Case 50: N = "D3"
          Case 51: N = "D#3"
          Case 52: N = "E3"
          Case 53: N = "F3"
          Case 54: N = "F#3"
          Case 55: N = "G3"
          Case 56: N = "G#3"
          Case 57: N = "A3"
          Case 58: N = "A#3"
          Case 59: N = "B3"
          Case 60: N = "C4"
          Case 61: N = "C#4"
          Case 62: N = "D4"
          Case 63: N = "D#4"
          Case 64: N = "E4"
          Case 65: N = "F4"
          Case 66: N = "F#4"
          Case 67: N = "G4"
          Case 68: N = "G#4"
          Case 69: N = "A4"
          Case 70: N = "A#4"
          Case 71: N = "B4"
          Case 72: N = "C5"
          Case 73: N = "C#5"
          Case 74: N = "D5"
          Case 75: N = "D#5"
          Case 76: N = "E5"
          Case 77: N = "F5"
          Case 78: N = "F#5"
          Case 79: N = "G5"
          Case 80: N = "G#5"
          Case 81: N = "A5"
          Case 82: N = "A#5"
          Case 83: N = "B5"
          Case 84: N = "C6"
          Case 85: N = "C#6"
          Case 86: N = "D6"
          Case 87: N = "D#6"
          Case 88: N = "E6"
          Case 89: N = "F6"
          Case 90: N = "F#6"
          Case 91: N = "G6"
          Case 92: N = "G#6"
          Case 93: N = "A6"
          Case 94: N = "A#6"
          Case 95: N = "B6"
          Case 96: N = "C7"
          Case 97: N = "C#7"
          Case 98: N = "D7"
          Case 99: N = "D#7"
         Case 100: N = "E7"
         Case 101: N = "F7"
         Case 102: N = "F#7"
         Case 103: N = "G7"
         Case 104: N = "G#7"
         Case 105: N = "A7"
         Case 106: N = "A#7"
         Case 107: N = "B7"
         Case 108: N = "C8"
         Case 109: N = "C#8"
         Case 110: N = "D8"
         Case 111: N = "D#8"
         Case 112: N = "E8"
         Case 113: N = "F8"
         Case 114: N = "F#8"
         Case 115: N = "G8"
         Case 116: N = "G#8"
         Case 117: N = "A8"
         Case 118: N = "A#8"
         Case 119: N = "B8"
         Case 120: N = "C9"
         Case 121: N = "C#9"
         Case 122: N = "D9"
         Case 123: N = "D#9"
         Case 124: N = "E9"
         Case 125: N = "F9"
         Case 126: N = "F#9"
         Case 127: N = "G9"
        Case Else: N = "?"
    End Select

    GetNoteText = N

End Function
Public Sub ResetSustainParams()

    Dim K%

    If KitEdit.keSustain > 0 Then
       midiOutShortMsg hMidiOut, 127 * &H10000 + CHANNEL_SUSTAIN_CONTROLLER * &H100 + &HB0 + 9
    End If
    
    For K = 0 To 14
        If SynthParams1(K).siSustain > 0 Then
           If K < 9 Then
              midiOutShortMsg hMidiOut, 127 * &H10000 + CHANNEL_SUSTAIN_CONTROLLER * &H100 + &HB0 + K
           End If
           If K >= 9 Then
              midiOutShortMsg hMidiOut, 127 * &H10000 + CHANNEL_SUSTAIN_CONTROLLER * &H100 + &HB0 + K + 1
           End If
        End If
    Next

End Sub
